<script context="module" lang="ts">
    export interface NotificationsContext {
        openSuccessSnackbar: (reason: string) => void;
        openWarningSnackbar: (reason: string) => void;
        openErrorSnackbar: (reason: string) => void;
    }
</script>

<script lang="ts">
    import { notificationStore } from "$lib/stores/clientNotification.store";
    import { NotificationType } from "$lib/types/clientNotification.type";
    import Snackbar, { Label } from "@smui/snackbar";
    import Kitchen from "@smui/snackbar/kitchen";
    import "../app.css";
    import "material-icons/iconfont/material-icons.css";
    import { setContext } from "svelte";

    const clearNotification = () => {
        notificationStore.set({});
    };

    let kitchen: Kitchen;
    const openSuccessSnackbar = (reason: string) => {
        pushSnackbar(reason, "success");
    };
    const openWarningSnackbar = (reason: string) => {
        pushSnackbar(reason, "warning");
    };
    const openErrorSnackbar = (reason: string) => {
        pushSnackbar(reason, "error");
    };
    const pushSnackbar = (
        label: string,
        type: "success" | "warning" | "error"
    ) => {
        kitchen.push({
            props: {
                class: `snack-${type}`,
            },
            label,
            dismissButton: true,
        });
    };

    const notificationsContext: NotificationsContext = {
        openSuccessSnackbar,
        openWarningSnackbar,
        openErrorSnackbar,
    };
    setContext("notifications", notificationsContext);
</script>

<!-- global notifications at top of screen -->
<notification-wrapper class="place-content-center flex">
    {#if $notificationStore.type === NotificationType.error}
        <div
            class="fixed bg-white/100 mx-auto rounded-b-md drop-shadow-[0_2px_2px_rgb(0,0,0,0.40)] py-3 px-5 place-items-center flex z-[1002]"
        >
            <icon
                class="text-red-400 material-icons-outlined !text-1xl align-middle mr-5"
                >error</icon
            >
            <center class="">
                <div class="font-semibold block" data-test="notification-message">
                    {$notificationStore.title}
                </div>
                {$notificationStore.message}
            </center>
            <icon
                class="material-icons-outlined !text-1xl align-middle cursor-pointer ml-5"
                on:click={clearNotification}
                on:keydown={clearNotification}
                role="button"
                tabindex="0">close</icon
            >
        </div>
    {/if}
    {#if $notificationStore.type === NotificationType.success}
        <div
            class="fixed bg-white/100 mx-auto rounded-b-md drop-shadow-[0_2px_2px_rgb(0,0,0,0.40)] py-3 px-5 place-items-center flex z-[1002]"
        >
            <icon
                class="text-green-400 material-icons-outlined !text-1xl align-middle mr-5"
                >check_circle</icon
            >
            <center class="">
                <div class="font-semibold block">
                    {$notificationStore.title}
                </div>
                <div>
                    {@html $notificationStore.message}
                </div>
            </center>
            <icon
                class="material-icons-outlined !text-1xl align-middle cursor-pointer ml-5"
                on:click={clearNotification}
                on:keydown={clearNotification}
                role="button"
                tabindex="0">close</icon
            >
        </div>
    {/if}
</notification-wrapper>

<!-- <Kitchen bind:this={kitchen} dismiss$class="material-icons" /> -->
<slot />
